; 
;	SECURPIP.ASM   -  Make your PIP inaccessible
;	during wheel mode's restrict
;
;	Mike Allard and Fred Spinner  21 nov 1982
;
;	This program uses part of PIP's I/O space,
;	and is overwritten when you pip something.
;	Please be careful with this patch.
;
;	System Equates:
;
BASE	EQU	0000H
;
WHEEL	EQU	BASE+003EH	;location of ZCPR's Wheel Flag
SECURE	EQU	0	 	;Anything but this means accessible
START	EQU	BASE+04CEH	;Start of PIP's program
BDOS	EQU	BASE+5
PRSTR	EQU	9		;BDOS print string function
;
	ORG	BASE+0100H	;TPA
;
BEGIN	LDA	WHEEL		;Load wheel flag
	CPI	SECURE		;Restricted??? If so. . .
	JZ	NOACC		;. . .  print error message, exit.
	JMP	ACC		;Otherwise, print ready message.
;
NOACC	MVI	C,PRSTR		;Call BDOS print. . .
	LXI	D,MSGNO		;. . .function, and print. . .
	CALL	BDOS		;. . ."no entry" message.
	RET			;Return to CCP
;
MSGNO	DB	'PIP not accessible during Wheel Restrict',13,10,'$'
;
ACC	MVI	C,PRSTR		;Call BDOS print. . .
	LXI	D,MSGYES	;. . .function, and print. . .
	CALL	BDOS		;. . ."PIP ready" message.
	JMP	START		;Jump to start of PIP.
;
MSGYES	DB	'PIP Ver. 2.2 ready:',13,10,'$'
;
	END
